<?php

add_filter('plugins_api', 'fifu_plugin_info', 100, 3);

function fifu_plugin_info($res, $action, $args) {

    // do nothing if this is not about getting plugin information
    if ('plugin_information' !== $action) {
        return false;
    }

    $plugin_slug = 'fifu-premium'; // we are going to use it in many places in this function
    // do nothing if it is not our plugin
    if ($plugin_slug !== $args->slug) {
        return false;
    }

    $res = new stdClass();

    $changelog = json_decode(file_get_contents('https://fifu.app/changelog-premium'), true);
    $last = $changelog[fifu_version_number()];
    $changelog_html = '';
    $i = 0;
    foreach ($changelog as $key => $value) {
        $changelog_html .= '<h4>' . $key . '</h4>' . $value['description'] . '<br>';
        if ($i++ == 100)
            break;
    }

    $res->name = 'Featured Image from URL Premium';
    $res->slug = 'fifu-premium';
    $res->version = fifu_version_number();
    $res->tested = $last['tested'];
    $res->requires = $last['requires'];
    $res->requires_php = '7.0';
    $res->sections = array(
        'description' => '<h3>WordPress plugin for external featured image</h3><br>Since 2015 FIFU has helped thousands of websites worldwide to save money on storage, processing and copyright.<br><br>If you are tired of wasting time and resources with thumbnail regeneration, image optimization and never-ending imports, this plugin is for you.',
        'changelog' => $changelog_html
            // you can add your custom sections (tabs) here
    );

    // in case you want the screenshots tab, use the following HTML format for its content:
    // <ol><li><a href="IMG_URL" target="_blank"><img src="IMG_URL" alt="CAPTION" /></a><p>CAPTION</p></li></ol>
    if (!empty($remote->sections->screenshots)) {
        $res->sections['screenshots'] = $remote->sections->screenshots;
    }

    $res->banners = array(
        'low' => 'https://ps.w.org/featured-image-from-url/assets/banner-772x250.png?rev=1694895',
        'high' => 'https://ps.w.org/featured-image-from-url/assets/banner-1544x500.png?rev=1694895'
    );
    return $res;
}

